//---------------------------------------------------------------------------
// FACEMAN.CPP Game source code
// programmed by Brandon Blume for DOS and Win32 
// with Turbo C++ and Borland C++ Builder
// Copyright  2014 All rights reserved
//---------------------------------------------------------------------------
#include <iostream.h>
#include <stdlib.h>
#include <conio.h>
#include <time.h>

#pragma hdrstop

#include "faceman.hpp"
//---------------------------------------------------------------------------

Player player;
Gem gems[NUM_GEMS];

#pragma argsused
int main(int argc, char* argv[])
{
        const char sTitle[] = "WELCOME TO FACEMAN!";
        const char sAuthor[] = "created by: Brandon Blume";
        const char sStartgame[] = "Press ENTER to play . . .";
        const char sTooMany[] = "Too many moves! Have another go?";
        const char sTooBad[] = "Too bad! Why not try again?";


        clrscr();
        textmode(C40);
        _setcursortype(0);

        int state = -1;

        ChangeState(state, TITLE);
        InitPlayer(player, true);
        InitGem(gems, NUM_GEMS);

        while (!bQuit)
        {
                // UPDATE GAME
                
                if(state == TITLE)
                {}
                else if(state == PLAYING) {

                        GetGem(gems, NUM_GEMS, player); // Update Gems

                        if (player.gems == NUM_GEMS) { // If player got all gems
                                if(player.moves <= MAX_MOVES) { // If player didn't make too many moves
                                        if(player.moves < player.highscore || !player.highscore) // If player moves is less than best highscore or if highscore is blank
                                                player.highscore = player.moves; // Assign new highscore
                                        ChangeState(state,PLAYING);
                                }
                        }
                        if (player.moves > MAX_MOVES)
                                ChangeState(state,LOST);

                }
                else if(state == LOST)
                {}

                // DRAW GAME

                DrawGameBorder();

                if (state == TITLE)
                {
                        gotoxy((nGameXCentre - (sizeof(sTitle) / 2) + 1), (nGameYCentre / 2) + 1);
                        textcolor(WHITE);
                        cprintf("%s",sTitle);
                        
                        gotoxy((nGameXCentre - (sizeof(sAuthor) / 2) + 1), wherey() + 1);
                        textcolor(LIGHTBLUE);
                        cprintf("%s",sAuthor);

                        gotoxy(nGameXCentre, nGameYCentre);
                        textcolor(player.color);
                        putch(player.icon);

                        gotoxy((nGameXCentre - (sizeof(sStartgame) / 2) + 1),
                                nGameYCentre + (nGameYCentre / 2));
                        textcolor(LIGHTMAGENTA);
                        cprintf("%s", sStartgame);
                }
		else if (state == PLAYING) {
			DrawGem(gems, NUM_GEMS);
			DrawPlayer();
			DrawScore();
		}
		else if (state == LOST) {
                        if (player.moves > MAX_MOVES) {
			        gotoxy((nGameXCentre - (sizeof(sTooMany) / 2) + 1), (nGameYCentre / 2) + 1);
			        textcolor(WHITE);
			        cprintf("%s",sTooMany);
                        }
                        else {
                                gotoxy((nGameXCentre - (sizeof(sTooBad) / 2) + 1), (nGameYCentre / 2) + 1);
			        textcolor(WHITE);
			        cprintf("%s",sTooBad);
                        }

			gotoxy(nGameXCentre, nGameYCentre);
			textcolor(LIGHTRED);
			putch(1);

			gotoxy((nGameXCentre - (sizeof(sStartgame) / 2) + 1),
				nGameYCentre + (nGameYCentre / 2));
			textcolor(LIGHTMAGENTA);
			cprintf("%s", sStartgame);
		}

                if (argv[1])
                        DrawDebug();

                if (bSfx) {
                        gotoxy(WIDTH - 1, HEIGHT);
                        textcolor(YELLOW);
                        cprintf("%c",14);
                }

                // GAME INPUT

		DoAgain:
                cInput = getch();
                switch (cInput){
                        case 75: //LEFT
                                if (player.x > nGameMinX)
                                        player.x--;
                                        if (state == PLAYING) player.moves++;
                                break;
                        case 77: //RIGHT
                                if (player.x < nGameMaxX)
                                        player.x++;
                                        if (state == PLAYING) player.moves++;
                                break;
			case 72: //UP
                                if (player.y > nGameMinY)
                                        player.y--;
                                        if (state == PLAYING) player.moves++;
                                break;
                        case 80: //DOWN
                                if (player.y < nGameMaxY)
                                        player.y++;
                                        if (state == PLAYING) player.moves++;
                                break;
                        case 71: //HOME
                                if (player.x != nGameMinX) {
                                        player.x = nGameMinX;
                                        if (state == PLAYING) player.moves++;
                                }
                                break;
                        case 79: //END
                                if(player.x != nGameMaxX) {
                                        player.x = nGameMaxX;
                                        if (state == PLAYING) player.moves++;
                                }
                                break;
			case 73: //PGUP
                                if (player.y != nGameMinY) {
                                        player.y = nGameMinY;
                                        if (state == PLAYING) player.moves++;
                                }
                                break;
                        case 81: //PGDN
                                if (player.y != nGameMaxY) {
                                        player.y = nGameMaxY;
                                        if (state == PLAYING) player.moves++;
                                }
                                break;
                        case '5':
			case 'c':
                                if (player.x != nGameXCentre) {
                                        if(player.y != nGameYCentre) {
                                                player.x = nGameXCentre;
                                                player.y = nGameYCentre;
                                                if (state == PLAYING) player.moves++;
                                        }else {
                                                player.x = nGameXCentre;
                                                if (state == PLAYING) player.moves++;
                                        }
                                }else if (player.y != nGameYCentre) {
                                        player.y = nGameYCentre;
                                        if (state == PLAYING) player.moves++;
                                }
                                break;
                        case 27: //ESC
                                switch (state){
                                        case LOST:
                                        case TITLE:
                                                bQuit = true;
                                                break;
                                        case PLAYING:
						ChangeState(state, LOST);
                                                break;
                                }
                                break;
                        case 13: //ENTER
                                switch (state){
                                        case LOST:
                                        case TITLE:
                                                ChangeState(state, PLAYING);
                                                break;
                                }
                                break;
                        case 60:
                        case 's':
                                if (bSfx) bSfx = false;
                                else bSfx = true;
                                break;

			default:
				goto DoAgain;
                }            
                clrscr();
        }
        textcolor(LIGHTGRAY);
        textmode(C80);
        _setcursortype(2);
        clrscr();

        return 0;
}
//---------------------------------------------------------------------------  
void DrawGameBorder() {
        textcolor(BLUE);

        // DRAW TOP BORDER
        gotoxy(nBorderMinX,nBorderMinY);
        putch(201);
	for (int iii = nBorderMinX + 1; iii < nBorderMaxX; iii++)
                putch(205);
        putch(187);

        // DRAW SIDE BORDERS
	for (int jjj = nBorderMinY + 1; jjj < nBorderMaxY; jjj++) {
                gotoxy(nBorderMinX,jjj);
                putch(186);
                gotoxy(nBorderMaxX,jjj);
                putch(186);
        }

        // DRAW BOTTOM BORDER
        gotoxy(nBorderMinX,nBorderMaxY);
        putch(200);
	for (int kkk = nBorderMinX + 1; kkk < nBorderMaxX; kkk++)
                putch(205);
        putch(188);
}

void InitPlayer(Player &player, bool first)
{
        player.ID = PLAYER;
        player.icon = 2;
        player.color = YELLOW;
        player.x = nGameXCentre;
        player.y = nGameYCentre;
//        player.life = 100;
        player.gems = 0;

        if(first)
                player.highscore = 0;

        player.moves = 0;
}
void DrawPlayer(){
        gotoxy(player.x, player.y);
        textcolor(player.color);
        putch(player.icon);
}

void InitGem(Gem gems[], int size)
{
        bool array[WIDTH][HEIGHT] = {false};
        array[nGameXCentre][nGameYCentre] = true;

        for(int i = 0; i < size; i++) {
                gems[i].ID = GEM;
                gems[i].live = true;
                gems[i].icon = 4;
                gems[i].color = LIGHTMAGENTA;

                time_t t;
		srand((unsigned) time(&t));

                gems[i].x = nGameMinX + (rand() % nGameW);
                gems[i].y = nGameMinY + (rand() % nGameH);

                while (array[gems[i].x][gems[i].y]) {
                        gems[i].x = nGameMinX + (rand() % nGameW);
                        gems[i].y = nGameMinY + (rand() % nGameH);
                }
                array[gems[i].x][gems[i].y] = true;
        }
}
void DrawGem(Gem gems[], int size) {
        for(int i = 0; i < size; i++) {
                if(gems[i].live){
                        textcolor(gems[i].color);
                        gotoxy(gems[i].x,gems[i].y);
                        putch(gems[i].icon);
                }
        }
}
void GetGem(Gem gems[], int size, Player &player)
{
	for(int i = 0; i < size; i++)
	{
		if(gems[i].live)
		{
			if(gems[i].x == player.x && gems[i].y == player.y)
			{
				player.gems++;
				gems[i].live = false;
                                if (bSfx) putch(7);
			}
		}
	}
}

void DrawScore()
{
        gotoxy(1,1);
        textcolor(LIGHTGRAY);
        cprintf("GEMS: ");

        textcolor(YELLOW);
        cprintf("%i",NUM_GEMS - player.gems);

        textcolor(LIGHTGRAY);
        cprintf(" | MOVES: ");

        textcolor(YELLOW);
        cprintf("%i",player.moves);

        gotoxy(WIDTH - 15, 1);
        textcolor(LIGHTGRAY);
        cprintf("BEST: ");

        textcolor(YELLOW);
        cprintf("%i",player.highscore);

        gotoxy(WIDTH - 6, 1);
        textcolor(LIGHTGRAY);
        cprintf(" moves");
}

void ChangeState(int &state, int newState)
{
        int prevState;

	if(state == TITLE)
	{}
	else if(state == PLAYING)
	{}
	else if(state == LOST)
	{}

        prevState = state;
	state = newState;

	if(state == TITLE)
	{}
	else if(state == PLAYING)
	{
                if (prevState != TITLE) InitPlayer(player, false);
                else InitPlayer(player, true);
		InitGem(gems, NUM_GEMS);
	}
	else if(state == LOST)
	{}
}

void DrawDebug(){
        gotoxy(1,HEIGHT);
        textcolor(DARKGRAY);
        cprintf("X: %i Y: %i int: %i char: %c",player.x, player.y, cInput, cInput);
}
