//---------------------------------------------------------------------------
// FACEMAN.HPP Game header file
// programmed by Brandon Blume for DOS and Win32 
// with Turbo C++ and Borland C++ Builder
// Copyright  2014 All rights reserved
//---------------------------------------------------------------------------
#define WIDTH 40
#define HEIGHT 25
#ifndef bool
 #define bool int
 #define false 0
 #define true 1
#endif

#define NUM_GEMS 20
#define MAX_MOVES 100

const int nBorderMinX = 2;
const int nBorderMaxX = WIDTH - 1;
const int nBorderMinY = 2;
const int nBorderMaxY = HEIGHT - 1;
const int nBorderW = nBorderMinX + nBorderMaxX;
const int nBorderH = nBorderMinY + nBorderMaxY;

const int nGameMinX = nBorderMinX + 1;
const int nGameMaxX = nBorderMaxX - 1;
const int nGameMinY = nBorderMinY + 1;
const int nGameMaxY = nBorderMaxY - 1;
const int nGameW = (nGameMaxX - nGameMinX) + 1;
const int nGameH = (nGameMaxY - nGameMinY) + 1;

const int nGameXCentre = (nGameW / 2) + nGameMinX;
const int nGameYCentre = (nGameH / 2) + nGameMinY;

enum STATE {TITLE, PLAYING, LOST};
enum IDS {PLAYER, GEM};

bool bSfx = true;
bool bQuit = false;
char cInput = 0;

struct Player{
        int ID;
        char icon;
        int color;
        int x;
        int y;
//        int life;
        int gems;
        long moves;
        long highscore;
};

struct Gem{
        int ID;
        char icon;
        int color;
        int x;
        int y;
	bool live;
};

void DrawGameBorder();

void InitPlayer(Player &player, bool first);
void DrawPlayer();

void InitGem(Gem gems[], int size);
void DrawGem(Gem gems[], int size);
void GetGem(Gem gems[], int size, Player &player);

void DrawScore();
void DrawDebug();

void ChangeState(int &state, int newState);
